#!/bin/bash

# DjVuSplitPages

# (c) 2005 Maxim Tyurin <mrkooll@bungarus.info>
# Licence: GPL

#       DjVu
#    ""

#      - ,
#       1  8 

#    
# ImageMagick
# djvu-utils
# libtiff-utils

if [ -z "$1" ]; then
 echo "USAGE: DjVuSplitPages.sh filename.djvu"
 exit;
fi

mkdir "$TMP/DjVuSplitPages-$1"
cp "$1"  "$TMP/DjVuSplitPages-$1"
cd "$TMP/DjVuSplitPages-$1"
#    tiff
ddjvu -format=tiff "$1" ${1%%.djvu}.tif && rm -f "$1"
#   tiff  
tiffsplit ${1%%.djvu}.tif page- && rm -f ${1%%.djvu}.tif

#     ( )
let pagenum=100000
ls -1 page-*.tif | sort | while read f;
do 
#   
  is=$(tiffinfo "$f" | grep Image)
  Iwidth=$(echo $is | awk '{print($3)}')
  let "Iwidth2 = $Iwidth / 2"
  Ilength=$(echo $is | awk '{print($6)}')
#   
  let bits=$(tiffinfo "$f" | grep "Bits/Sample" | awk '{print($2)}')
#  ( 5%   )
  let "pr = $Iwidth2 / 100 * 5"
  let "z = $Iwidth2 + $pr"
  convert -crop "$z"x"$Ilength" "$f" "$pagenum".tif
  if [ $bits -eq 1 ]; then
      cjb2 -dpi 300 -lossless "$pagenum".tif "$pagenum".djvu || exit
      rm -f "$pagenum".tif
  else
      convert -quality 0 "$pagenum".tif "$pagenum".ppm && rm -f "$pagenum".tif
      cpaldjvu -dpi 300 -colors 256 -bgwhite "$pagenum".ppm "$pagenum".djvu || exit
      rm -f "$pagenum".ppm
  fi
  if [ $pagenum -eq 100000 ]; then
      djvm -c "book-$1" "$pagenum".djvu && rm -f "$pagenum".djvu
  else
      djvm -i "book-$1" "$pagenum".djvu && rm -f "$pagenum".djvu
  fi
  let pagenum+=1
  let "z2 = $Iwidth2 - $pr"
  convert -crop "$z"x"$Ilength"+"$z2"+0 "$f" "$pagenum".tif
  if [ $bits -eq 1 ]; then
      cjb2 -dpi 300 -lossless "$pagenum".tif "$pagenum".djvu || exit
      rm -f "$pagenum".tif
  else
      convert -quality 0 "$pagenum".tif "$pagenum".ppm && rm -f "$pagenum".tif
      cpaldjvu -dpi 300 -colors 256 -bgwhite "$pagenum".ppm "$pagenum".djvu || exit
      rm -f "$pagenum".ppm
  fi
  djvm -i "book-$1" "$pagenum".djvu && rm -f "$pagenum".djvu
  let pagenum+=1
  rm -f "$f"
done
